#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <random>
#include <set>

using namespace std;

bool ok(vector<long long> a, long long x) {
    for (int i = 1; i < a.size(); i++) {
        long long k = (a[i - 1] - x);
        if (i == 1) {
            long long k1 = (a[i] - x);
            long long d = (k1 - k);
            if (d % 2 != 0) return 0;
            d /= 2;
            k -= d;
        }
        if (k < 0) return 0;
        a[i - 1] += k;
        a[i] += 2 * k;
    }

    for (long long y : a) {
        if (y != x) return 0;
    }
    return 1;
}

void solve() {
    int n; cin >> n;
    vector<long long> a(n);
    long long mn = 1e9;
    for (long long &x : a) {
        cin >> x;
        mn = min(mn, x);
    }
    int ind = 0;
    for (int i = 0; i < n; i++)
        if (a[i] == mn)
            ind = i;
    vector<long long> b;
    for (int i = 0; i < n; i++) {
        b.push_back(a[ind]);
        ind++;
        ind %= n;
    }
    a = b;
    long long s = 0;
    for (long long x : a) {
        s += x;
        s %= 3;
    }
    long long ans = 0;
    for (long long ost = 2; ost >= 0; ost--) {
        if ((ost * n) % 3 == s) {
            long long l = -1, r = 1e9;
            while (r - l > 1) {
                long long m = (r + l) / 2;
                if (ok(a, 3 * m + ost)) l = m;
                else r = m;
            }
            ans = max(ans, 3 * l + ost);
        }
    }
    cout << ans;
}

int main() {
    cin.tie(0)->sync_with_stdio(false);
    int tests = 1; cin >> tests;
    while (tests--) {
        solve();
        cout << '\n';
    }
}