#include "bits/stdc++.h"

using namespace std;
using ll = long long;

int n, m;
vector<vector<int>> g, gr;

void dfs(vector<vector<int>> &gg, vector<char> &used, int v, int p, vector<int> &vv) {
    if (used[v] == 1) return;
    used[v] = 1;
    for (int to : gg[v]) {
        if (to == p) continue;
        dfs(gg, used, to, v, vv);
    }
    vv.push_back(v);
}

vector<int> topSort(int nn, vector<vector<int>> &g) {
    vector<char> used(nn, 0);
    vector<int> v;
    for (int i = 0; i < nn; i++) {
        dfs(g, used, i, i, v);
    }
    return v;
}

int colorize(vector<vector<int>> &gg, vector<int> &color, int v, int c) {
    if (color[v] != 0) return 0;
    color[v] = c;
    int s = 1;
    for (int to : gg[v])
        s += colorize(gg, color, to, c);
    return s;
}

void print(vector<int> &v) {
    for (int i : v)
        cout << i+1 << " ";
    cout << endl;
}

int delUp(int x) {
    return x / 2 + (x % 2);
}

void check(vector<int> &vv) {
    set<int> ms;
    for (int i : vv)
        ms.insert(i);
    int a = 0, c = 0;
    for (int a : vv) {
        for (int b : g[a]) {
            if (ms.contains(b)) {
                a++;
                if (b > a) c++;
            }
        }
    }
    if (c * 2 >= a)
        reverse(vv.begin(), vv.end());
}

void solve() {
    cin >> n >> m;
    g.assign(n, vector<int>());
    gr.assign(n, vector<int>());
    vector<pair<int,int>> mm;
    for (int i = 0; i < m; i++) {
        int a, b; cin >> a >> b; a--, b--;
        g[a].push_back(b);
        gr[b].push_back(a);
        mm.emplace_back(a, b);
    }
    vector<int> revTop = topSort(n, gr);
    vector<int> color(n, 0);
    int c = 0;
    reverse(revTop.begin(), revTop.end());
    for (int i : revTop) {
        if (color[i] == 0) {
            c++;
            int x = colorize(g, color, i, c);
        }
    }
    vector<vector<int>> gc(c, vector<int>());
    for (auto [a, b] : mm) {
        int c1 = color[a], c2 = color[b]; c1--, c2--;
        if (c1 == c2) continue;
        gc[c1].push_back(c2);
    }
    vector<int> ansTop = topSort(c, gc);
    vector<vector<int>> kkk(c);
    for (int i = 0; i < n; i++) {
        kkk[color[i]-1].push_back(i);
    }
    vector<int> ans;
    reverse(ansTop.begin(), ansTop.end());
    for (int cc : ansTop) {
        check(kkk[cc]);
        for (int i : kkk[cc])
            ans.push_back(i);
    }
    print(ans);
}

int main() {
    ios::sync_with_stdio(false); cin.tie(0);
    int t; cin >> t;
    for (int i = 0; i < t; i++)
        solve();
}
