#include <bits/stdc++.h>
using namespace std;

void solve_test() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    vector<int> vis(n);
    vector<int> topsort;
    auto dfs1 = [&](auto dfs1, int v) -> void {
        vis[v] = 1;
        for (int u : g[v]) {
            if (!vis[u]) {
                dfs1(dfs1, u);
            }
        }
        topsort.push_back(v);
    };
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        g[u].push_back(v);
    }
    for (int v = 0; v < n; ++v) {
        if (!vis[v])
            dfs1(dfs1, v);
    }
    auto calc = [&]() -> int {
        int res = 0;
        vector<int> p(n);
        for (int i = 0; i < n; ++i) {
            p[topsort[i]] = i;
        }
        for (int v = 0; v < n; ++v) {
            for (int u : g[v]) {
                if (p[u] > p[v])
                    res++;
            }
        }
        return res;
    };
    if (calc() < (m + 1) / 2) {
        reverse(topsort.begin(), topsort.end());
    }
    for (int x : topsort)
        cout << x + 1 << " ";
    cout << '\n';

}

int main() {
//    freopen("in.txt", "r", stdin);
    int tt;
    cin >> tt;
    while (tt--) {
        solve_test();
    }
    return 0;
}
