#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

/*
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2")
*/

using namespace std;
using namespace __gnu_pbds;

#define pb push_back
#define eb emplace_back
#define f first
#define s second
#define deb(a) cerr << #a << " = " << a << "\n";
#define int long long
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tree<
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update>
        ordered_set;
/*gp_hash_table <int, int> table;
const int RANDOM = chrono::high_resolution_clock::now()
        .time_since_epoch().count();
struct chash {
    int operator () (int x) const { return x ^ RANDOM; }
};
gp_hash_table <key, int, chash> table ;
typedef cc_hash_table <int, int, hash <int>> ht;*/

const ll INF = 2e18;
const ll MOD1 = 1e9 + 7;
const ll MOD2 = 998244353;
const int inf = 1e9;
const ld EPS = 1e-8;
const ld Pi = acosl(-1);
const int P1 = 31;
const int P2 = 37;
const int dx[4] = {0, 0, 1, -1};
const int dy[4] = {1, -1, 0, 0};
const int sq = 666;

int qqq = 1;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

ll binpow (ll a, ll n) {
    if (n == 0) {
        return 1;
    }
    if (n % 2 == 0) {
        __int128_t b = binpow(a, n / 2);
        return b * b;
    }
    __int128_t x = binpow(a, n - 1);
    return a * x;
}

bool check(int m, vector<int>& a) {
    int n = (int)a.size();
    vector <int> c(a.size());
    for (int i = 0; i < a.size(); i++) {
        if (a[i] < m) {
            return false;
        }
        c[i] = a[i] - m;
    }

    int mini = INF;
    for (int i = 0; i < c.size(); i++) {
        mini = min(mini, c[i] / 3);
    }


    int min_pos = min_element(c.begin(), c.end()) - c.begin();

    auto check_good = [n, &c](vector<int>&b) {
        bool good = true;
        for (int i = 0; i < n; i++) {
            if (c[i] != 2 * b[i] + b[(i + 1) % n]) {
                good = false;
            }
        }
        return good;
    };

    vector <int> b(n);
    for (int b_pos = -1000; b_pos < 1000; b_pos++) {
        b[min_pos] = b_pos + mini;
        for (int i = 0; i < n - 1; i++) {
            b[(min_pos + i + 1) % n] = c[(min_pos + i) % n] - 2 * b[(min_pos + i) % n];
        }

        if (check_good(b)) {
            return true;
        }
    }

    return false;
}

int find_ans_by_mod(int mod, vector <int> &a) {
    int l = 0, r = 1e9 + 10;
    while( r - l > 1) {
        int m = (r + l) / 2;
        if (check(mod + 3 * m, a)) {
            l = m;
        } else {
            r = m;
        }
    }

    return mod + 3 * l;
}

void solve() {
    int n;
    cin >> n;
    vector <int> a(n);
    for (auto &i: a) {
        cin >> i;
    }

    int ans1 = (check(0, a) ? find_ans_by_mod(0, a) : 0);
    int ans2 = (check(1, a) ? find_ans_by_mod(1, a) : 0);
    int ans3 = (check(2, a) ? find_ans_by_mod(2, a) : 0);

    cout << max({ans1, ans2, ans3}) << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> qqq;
    while (qqq--) {
        solve();
    }
    return 0;
}