#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <map>

using namespace std;

void solve() {
	int n, A, B;
	cin >> n >> A >> B;
	map<int, vector<int>> m;
	for (int i = 0; i < n; ++i) {
		int a, b;
		cin >> a >> b;
		m[a].emplace_back(b);
	}
	vector<vector<pair<int, int>>> pp;
	for (auto& e : m) {
		sort(e.second.begin(), e.second.end());
		vector<pair<int, int>> p;
		int prmx = 0;
		p.emplace_back(prmx, e.second.size());
		for (int i = 0; i < e.second.size(); ++i) {
			int diff = e.second[i] - 2 * i - 1;
			int c = max(0, (diff + 1) / 2);
			prmx = max(prmx, c);
			p.emplace_back(prmx, e.second.size() - i - 1);
		}
		pp.emplace_back(std::move(p));
	}
	
	vector<int64_t> dp(n + 10, 1e18);
	vector<int64_t> dp2(n + 10, 1e18);
	dp[0] = 0;
	for (auto& e : pp) {
		dp2.assign(n + 10, 1e18);
		for (int i = 0; i < dp.size(); ++i) {
			for (auto& x : e) {
				if (i + x.second < dp.size()) {
					dp2[i + x.second] = min(dp2[i + x.second], dp[i] + x.first);
				}
			}
		}
		std::swap(dp2, dp);
	}
	int64_t ans = dp[0];
	for (int64_t i = 0; i < dp.size(); ++i) {
		ans = min(ans, max(dp[i], i));
	}
	cout << ans << "\n";
}


int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}