#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")

using namespace std;

using ll = long long;

template<typename T>
ostream& operator<<(ostream& ost, vector<T>& v){
    ost<<"[";
    for(auto x : v)
        ost<<x<<" ";
    return ost<<"]\n";
}



void solve()
{
    int n;
    cin >> n;
    set<pair<ll,ll>>r,b;
    ll nr=0,nb=0;
    ll rx=-1,ry=-1;
    for(int i=0;i<n;i++)
    {
        ll x,m;
        char c;
        cin >> x >> m >> c;
        if(c=='R')
        {
            r.insert({x, m});
            nr+=m;
            if(rx==-1)
                rx=x;
        }
        else
        {
            b.insert({x, m});
            nb+=m;
        }
    }
    if(nr==nb)
    {
        cout << "Draw ";
        cout << rx;
        cout << " +" << "\n";
        return;
    }
    ll sum=0;
    if(nb>nr)
    {
        while(!r.empty())
        {
            auto pr=*r.rbegin();
            auto pb=*b.rbegin();
            r.erase(*r.rbegin());
            b.erase(*b.rbegin());
            if(pr.second<pb.second)
            {
                sum+=(pb.first-pr.first)*pr.second;
                b.insert({pb.first,pb.second-pr.second});
            }
            else
            {
                sum+=(pb.first-pr.first)*pb.second;
                r.insert({pr.first,pr.second-pb.second});
            }
            if(sum<0)
            {
                cout << "Draw ";
                cout << rx;
                cout << " +" << "\n";
                return;
            }
        }
        cout << "Second" << "\n";
        return;
    }
    else
    {
        sum=1;
        while(!b.empty())
        {
            auto pr=*r.rbegin();
            auto pb=*b.rbegin();
            r.erase(*r.rbegin());
            b.erase(*b.rbegin());
            if(pr.second<pb.second)
            {
                sum+=(pr.first-pb.first)*pr.second;
                b.insert({pb.first,pb.second-pr.second});
            }
            else
            {
                sum+=(pr.first-pb.first)*pb.second;
                r.insert({pr.first,pr.second-pb.second});
            }
            if(sum<0)
            {
                cout << "Draw ";
                cout << rx;
                cout << " +" << "\n";
                return;
            }
        }
        cout << "First ";
        cout << rx;
        cout << " +" << "\n";
        return;
    }

}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin>>t;
    while(t--)
        solve();
}
