//
// Created by qf on 16.11.2024.
//
#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#define ll long long
#define ld long double
#define all(x) x.begin(),x.end()

using namespace std;

constexpr ll MOD = 998244353;

ll n, m, k;
ll f[105];

vector<pair<ll, ll>> c;
vector<ll> nxt;

ll binpow(ll h, ll r) {
    ll l = 1;
    while (r) {
        if (r & 1) {
            l = l * h % MOD;
        }
        h = h * h % MOD;
        r /= 2;
    }
    return l;
}

struct bint {
    ll v;
};

bint operator+(bint a, bint b) {
    return {(a.v + b.v) % MOD};
}

bint operator-(bint a, bint b) {
    return {(a.v + MOD - b.v) % MOD};
}

bint operator*(bint a, bint b) {
    return {(a.v * b.v) % MOD};
}

bint operator/(bint a, bint b) {
    return {(a.v * binpow(b.v, MOD - 2)) % MOD};
}

bint operator^(bint a, ll b) {
    return {binpow(a.v, b)};
}

bint operator+=(bint& a, bint b) {
    a = a + b;
    return a;
}

bint operator-=(bint& a, bint b) {
    a = a - b;
    return a;
}

bint operator*=(bint& a, bint b) {
    a = a * b;
    return a;
}

bint operator/=(bint& a, bint b) {
    a = a / b;
    return a;
}

bint operator^=(bint& a, ll b) {
    a = a ^ b;
    return a;
}

bint ff(ll a) {
    if (k == 2) {
        return {(a + 1) % 2};
    } else {
        bint kk{k};
        bint an = ((kk - bint{2}) * (((((kk - bint{1}) ^ 2) ^ (a / 2 + 1)) - bint{1}) / (((kk - bint{1}) ^ 2) - bint{1}) - bint{1})) / (kk - bint{1}) + bint{1};
        if (a & 1) {
            an = ((kk - bint{1}) ^ a) - an;
        }
        // cout << ((kk - bint{1}) ^ a).v << " " << an.v << endl;
        return an;
    }
}

bint dfs(ll l, ll r) {
    if (l + 1 == r) {
        return {1};
    }
    ll j = l;
    vector<pair<ll, ll>> zz;
    ll am = r - l - 1;
    while (j < r) {
        auto it = std::upper_bound(c.begin(), c.end(), make_pair(j, (ll)-1e18));
        if (it == c.end() || it->first >= r || -it->second > r) {
            break;
        }
        auto pos = it - c.begin();
        pos = nxt[pos];
        if (pos >= c.size()) {
            break;
        }
        auto o = -c[pos].second;
        am -= o - c[pos].first - 1;
        zz.emplace_back(c[pos].first, o);
        nxt[pos] = nxt[pos + 1];
        j = o;
    }
    bint ans = ff(am);
    // cout << l << " " << r << endl;
    for (auto [x, y] : zz) {
        ans *= dfs(x, y);
    }
    return ans;
}

void solve() {
    cin >> n >> m >> k;
    c.clear();
    nxt.clear();
    for (int i = 0; i < m; i++) {
        ll x, y;
        cin >> x >> y;
        c.push_back({x, -y});
        nxt.push_back(i);
    }
    nxt.push_back(m);
    sort(all(c));
    bint ans = dfs(1, n) * bint{k} * bint{(k - 1)};
    cout << ans.v << endl;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    //cout << ff(1).v << " " << 1001 * 1000 * 999 % MOD << endl;
}

/*
4
4 1 3
1 3
5 0 2
9 4 3
1 3
1 6
4 6
6 8
3 0 1001

 */