#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int ms[600];

int main()
{
    ios_base::sync_with_stdio(false);

    int n(0);
    cin >> n;

    for (int i(0); i < n; i++)
    {
        string time("");
        cin >> time;

        int num((time[0] - '0') * 60);
        num += (time[2] - '0') * 10;
        num += time[3] - '0';

        ms[num] = 1;
    }

    bool twoClock(false);
    for (int i(420); i <= 540; i++)
    {
        int sc(0);
        for (int j(i); j <= i + 10 && j <= 540; j++)
        {
            if (ms[j] == 1)
                sc++;

            if (sc >= 3)
            {
                cout << 0;
                return 0;
            }
        }
        if (sc == 2)
            twoClock = true;

        sc = 0;
    }

    if (twoClock)
        cout << 1;
    else
        cout << 2;

    return 0;
}