#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const int N = 1e5 + 100;
const ll mod = 998244353;
ll f12[N], f23[N], f13[N];

void init() {
    f12[1] = 1;
    f23[1] = 1;
    f13[1] = 2;
    for (int i = 2; i < N; ++i) {
        f12[i] = (f13[i - 1] + f23[i - 1] + 1) % mod;
        f23[i] = f12[i];
        f13[i] = (3 * f13[i - 1] + 2) % mod;
    }
}

int n;

//ll getf(int a, int b) {
//    if (a > b) {
//        swap(a, b);
//    }
//
//}

ll f(vector<int> &cur, int pos = 1) {
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        if (pos == cur[i]) {
            continue;
        }
        if (pos == 1) {
            if (cur[i] == 2) {
                ans = (ans + f13[n - i - 1] + 1) % mod;
                pos = 3;
            } else if (cur[i] == 3) {
                ans = (ans + 2 * f13[n - i - 1] + 2) % mod;
                pos = 1;
            }
        } else if (pos == 2) {
            if (cur[i] == 1) {
                ans = (ans + f23[n - i - 1] + 1) % mod;
                pos = 3;
            } else if (cur[i] == 3) {
                ans = (ans + f23[n - i - 1] + 1) % mod;
                pos = 1;
            }
        } else if (pos == 3) {
            if (cur[i] == 2) {
                ans = (ans + f13[n - i - 1] + 1) % mod;
                pos = 1;
            } else if (cur[i] == 1) {
                ans = (ans + 2 * f13[n - i - 1] + 2) % mod;
                pos = 3;
            }
        }
    }
    return ans;
}

void solve() {
    cin >> n;
    vector<int> cur(n), cur2(n);
    for (int i = 0; i < n; ++i) {
        cin >> cur[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> cur2[i];
    }
    std::reverse(cur.begin(), cur.end());
    std::reverse(cur2.begin(), cur2.end());
//    cout << f(cur) << ' ' << f(cur2) << '\n';
    cout << (abs(f(cur) - f(cur2)) + mod) % mod << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    init();
    while (t--)
        solve();
    return 0;
}
