#include <bits/stdc++.h>

using namespace std;
using ull = unsigned long long;
using ll  = long long;
using ld = long double;
#define pb push_back
#define fi first 
#define se second
#define vi vector<int> 
#define vl vector<ll> 
#define vvi vector<vi> 
#define vvl vector<vl> 
#define pii pair<int,int>
#define pll pair<ll, ll>
#define vii vector<pii> 
#define vll vector<pll> 
#define vvii vector<vii>
#define vvll vector<vll>
#define all(x) begin(x), end(x)
#define sz(x) (int)x.size()

#ifndef LOCAL
#define cerr if (0) cerr
#endif

template <typename T, typename V> ostream &operator<<(ostream &out, pair<T, V> p) {
	out << "(" << p.fi << ", " << p.se << ")";
	return out;
}

template <typename T> ostream &operator<<(ostream &out, vector<T> v) {
	out << "[";
	for (T e : v)
		out << e << ", ";
	out << "]";
	return out;
}

template <typename T> ostream &operator<<(ostream &out, vector<vector<T>> v) {
	out << "[";
	for (auto e : v)
		out << e << ",\n";
	out << "]";
	return out;
}

template <typename T, typename C> ostream &operator<<(ostream &out, set<T, C> s) {
	out << "{";
	for (T e : s)
		out << e << ", ";
	out << "}";
	return out;
}

template <typename T, typename V, typename C> ostream &operator<<(ostream &out, map<T, V, C> m) {
	out << "{";
	for (auto e : m)
		out << e << ", ";
	out << "}";
	return out;
}

void solve() {
    int n; cin >> n;

    vii a(n);
    for(int i = 0; i < n; i++)
        cin >> a[i].se; 
    for(int i = 0; i < n; i++)
        cin >> a[i].fi;
    sort(all(a));

    vi d(n);
    for(int i = 0; i < n; i++){
        d[i] = a[i].fi - a[i].se;
        if(d[i] < 0){
            cout << -1 << '\n';
            return;
        }
        if(i == 0) continue;

        if(d[i-1] > d[i]){
            cout << -1 << '\n';
            return;
        }

        if(a[i-1].fi == a[i].fi && d[i-1] != d[i]){
            cout << -1 << '\n';
            return;
        }
    }
        
    cout << d[n-1] << '\n';
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	// freopen("in.txt", "r", stdin);
	// freopen("out.txt", "w", stdout);

	// cout << fixed << setprecision(10);

	int t = 1;
	cin >> t;

	while (t --> 0) {
		solve();
	}

	return 0;
}