#include <bits/stdc++.h>

using namespace std;
using ull = unsigned long long;
using ll  = long long;
using ld = long double;
#define pb push_back
#define fi first 
#define se second
#define vi vector<int> 
#define vl vector<ll> 
#define vvi vector<vi> 
#define vvl vector<vl> 
#define pii pair<int,int>
#define pll pair<ll, ll>
#define vii vector<pii> 
#define vll vector<pll> 
#define vvii vector<vii>
#define vvll vector<vll>
#define all(x) begin(x), end(x)
#define sz(x) (int)x.size()

#ifndef LOCAL
#define cerr if (0) cerr
#endif

template <typename T, typename V> ostream &operator<<(ostream &out, pair<T, V> p) {
	out << "(" << p.fi << ", " << p.se << ")";
	return out;
}

template <typename T> ostream &operator<<(ostream &out, vector<T> v) {
	out << "[";
	for (T e : v)
		out << e << ", ";
	out << "]";
	return out;
}

template <typename T> ostream &operator<<(ostream &out, vector<vector<T>> v) {
	out << "[";
	for (auto e : v)
		out << e << ",\n";
	out << "]";
	return out;
}

template <typename T, typename C> ostream &operator<<(ostream &out, set<T, C> s) {
	out << "{";
	for (T e : s)
		out << e << ", ";
	out << "}";
	return out;
}

template <typename T, typename V, typename C> ostream &operator<<(ostream &out, map<T, V, C> m) {
	out << "{";
	for (auto e : m)
		out << e << ", ";
	out << "}";
	return out;
}

bool check(char c, vector<string> &a) {
    for (auto s : a) {
        int n = (int)s.size();
        if (string(n, c) == s)
            return true;
    }

    return false;
}

const int INF = 1e9;

void solve() {
    int n, e;
    cin >> n >> e;

    vector<string> a(n);
    for (auto &x : a)
        cin >> x;
    
    char c_ans = '?';
    int ans = INF;
    for (char c = 'a'; c < 'a' + e; c++) {     
        if (check(c, a))
            continue;
        
        int cur = 0;

        for (auto s : a) {
            for (auto x : s) {
                if (x != c)
                    break;
                cur++;
            }
        }
        
        if (ans > cur) {
            ans = cur;
            c_ans = c;
        }
    }

    if (ans == INF) {
        cout << "NO";
        return;
    }

    cout << string(ans + 1, c_ans);
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	// freopen("in.txt", "r", stdin);
	// freopen("out.txt", "w", stdout);

	// cout << fixed << setprecision(10);

	int t = 1;
	// cin >> t;

	while (t --> 0) {
		solve();
	}

	return 0;
}