#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>
#include <map>
using namespace ::std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define fore(col) for (auto& val : col)
typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair<int, int> pii;


void doWork() {
    int n;
    cin >> n;
    vi e(n);
    vi s(n);
    fore(e)
        cin >> val;
    fore(s)
        cin >> val;
    int maxD = 0;
    vector<pii> vect;
    vect.reserve(n);
    forn(i, n) {
        if (s[i] - e[i] < 0) {
            cout << "-1" << endl;
            return;
        }
        maxD = max(maxD, s[i] - e[i]);
        vect.push_back({s[i], e[i]});
    }
    sort(vect.begin(), vect.end());
    forn(i, n-1) {
        if (vect[i].second > vect[i + 1].second) {
            cout << "-1" << endl;
            return;
        }
    }
    int delta = 0;
    fore(vect) {
        int d = val.first - val.second;
        if (d < delta) {
            cout << "-1" << endl;
            return;
        }
        delta = d;
    }

    cout << maxD << endl;

    
    
    
}

signed main() {
    int t = 1;
    cin >> t;
    while (t--) {
        doWork();
    }
    
}