#include <bits/stdc++.h>

using namespace std;

int dfs(int v, int c, vector<int>& col, const vector<vector<int>>& g, vector<int>& ans) {
    col[v] = c;
    int broken = 0;
    for (int u : g[v]) {
        if (!col[u]) {
            broken += dfs(u, c, col, g, ans);
        } else if (col[u] == c) {
            ++broken;
        }
    }
    ans.emplace_back(v);
    return broken;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n), rg(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        g[a].emplace_back(b);
        rg[b].emplace_back(a);
    }
    vector<int> ans, col(n);
    int cur_col = 1;
    int broken = 0;
    for (int i = 0; i < n; ++i) {
        if (!col[i]) {
            broken += dfs(i, cur_col, col, rg, ans);
            ++cur_col;
        }
    }
    if (broken <= m / 2) {
        for (int x : ans) cout << x + 1 << ' ';
        cout << '\n';
    } else {
        cout << "-1\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
