// ConsoleApplication2.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <string>

#define int long long

using namespace std;

int fromTime(string& a)
{
	return (a[0] - '0') * 60 + (a[2] - '0') * 10 + a[3] - '0' - 420;
}

class Pref
{
private:
	vector<int> p;
public:
	Pref(vector<int>& v)
	{
		p.resize(v.size() + 1);
		for (int i = 0; i < v.size(); i++)
			p[i + 1] = v[i] + p[i];
	}
	int get(int l, int r)
	{
		return p[r] - p[l];
	}
};

signed main()
{
	int size;
	cin >> size;
	vector<int> v(140, 0);
	while (size--)
	{
		string a;
		cin >> a;
		v[fromTime(a)] = 1;
	}
	Pref p(v);
	int res = 3;
	for (int i = 0; i <= 120; i++)
	{
		auto a = 3 - p.get(i, i + 11);
		if (a < res)
			res = a;
	}
	if (res < 0)
		res = 0;
	cout << res;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
