#include <bits/stdc++.h>

#define int long long
using namespace std;

void solve() {
    int n; cin >> n;
    vector<int> a(n);
    for (int& x : a) cin >> x;

    auto ok = [&](int x) {
        auto b = a;
        while (x > 0) {
            for (int i = 0; i < n; ++i) {
                if (b[i] % 2 != x % 2) {
                    b[i]--;
                    b[(i + 1) % n] -= 2;
                    if (b[i] < 0 || b[(i + 1) % n] < 0)
                        return false;
                }
            }
            for (int i = 0; i < n; ++i) {
                b[i] /= 2;
            }
            x /= 2;
        }
        return true;
    };

    int res = 0;
    for (int mod = 0; mod < 3; ++mod) {
        if (!ok(mod)) continue;
        int l = 0, r = 1e9 + 123;
        while (r - l > 1) {
            int m = l + r >> 1;
            if (ok(3 * m + mod)) l = m;
            else r = m;
        }
        res = max(res, 3 * l + mod);
    }
    cout << res << "\n";
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}