#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(a) (a).begin(), (a).end()
#define srt(a) sort((a).begin(), (a).end())
#define eb emplace_back

int n, m, cnt = 0;
vector<vector<pair<int, bool>>> g;
vector<int> used, sorted;

bool dfs(int v) {
    if (used[v] == 2)
        return true;
    if (used[v] == 1)
        return false;
    used[v] = 1;
    for (auto &[u, banned] : g[v]) {
        if (!banned && dfs(u)) {
            cnt++;
        } else {
            banned = true;
        }
    }
    used[v] = 2;
    sorted.eb(v);
    return true;
}

void test_case() {
    cin >> n >> m;
    cnt = 0;
    g.assign(n + 1, vector<pair<int, bool>> ());
    used.assign(n + 1, 0);
    sorted.clear();
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].eb(v, false);
    }
    for (int v = 1; v <= n; ++v) {
        dfs(v);
    }
    if (cnt >= (m + 1) / 2) {
        assert(sorted.size() == n);
        reverse(all(sorted));
        for (int &v : sorted) {
            cout << v << ' ';
        }
        cout << '\n';
    } else {
        cout << "-1\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tests = 1;
     cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        test_case();
    }
    return 0;
}
