#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define f first
#define s second
//#define x first
//#define y second
#define pb push_back
#define _ << ' ' <<
#define TEST ""
#define all(x) x.begin(), x.end()
#define mp make_pair
#define sz(x) (int)x.size()
//#define cerr if(0) cerr
//#define int long long
#define Time() (ld)clock() / CLOCKS_PER_SEC

//#pragma GCC optimize ("O3")
//#pragma GCC optimize ("Ofast")
//#pragma GCC target ("sse,sse2,sse3,sse4,avx,avx2")
//#pragma comment(linker, "/STACK:160777216")

//before loops:
//#pragma unroll(3)

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;

#ifdef LOCAL
    #define cerr cout
#else
    #define cerr if(0) cerr
#endif

//template<typename T>
//using orderd_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T1, typename T2>
__attribute__((always_inline)) common_type_t<T1, T2> min(const T1 &a, const T2 &b) {
    return a < b ? a : b;
}

template<typename T3, typename T4>
__attribute__((always_inline)) common_type_t<T3, T4> max(const T3 &a, const T4 &b) {
    return a > b ? a : b;
}

template<typename T>
using normal_queue = priority_queue<T, vector<T>, greater<T> >;

const int MOD = 998244353;

int add(int x, int y) {
    return x + y >= MOD ? x + y - MOD : x + y;
}

const int K = 1e5 + 5;

int a[K], b[K], c[K], d[K], e[K], f[K];

void precalc() {
    a[1] = 1;
    b[1] = 2;
    c[1] = 1;
    d[1] = 1;
    e[1] = 2;
    f[1] = 1;
    for (int k = 2; k < K; ++k) {
        a[k] = add(e[k - 1], 1);
        b[k] = add(a[k], a[k]);
        c[k] = add(f[k - 1], 1);
        d[k] = add(a[k], d[k - 1]);
        e[k] = add(b[k], e[k - 1]);
        f[k] = add(c[k], e[k - 1]);
    }
}

pair<int, int> solve_init(int n, int posA, int posB, int pos) {
    //cerr << n << " " << posA << " " << posB << " " << pos << endl;
    if (posA == posB) {
        return {0, pos};
    }
    if (abs(posA - posB) == 1) {
        if (pos == posA) {
            if (posA == 1) {
                return {add(f[n - 1], 1), 2 - posB};
            }
            return {add(e[n - 1], 1), 2 - pos};
        }
        if (pos == posB) {
            if (posB == 1) {
                return {add(f[n - 1], 1), 2 - posA};
            }
            //cerr << add(e[n - 1], 1) << endl;
            return {add(e[n - 1], 1), 2 - posB};
        }
        return {1, pos};
    }
#ifdef LOCAL
    assert(abs(posA - posB) == 2);
#endif // LOCAL
    if (pos == posA) {
        auto res = solve_init(n, 1, posB, posB);
        res.first = add(res.first, add(e[n - 1], 1));
        return res;
    }
    if (pos == posB) {
        auto res = solve_init(n, 1, posB, pos);
        res.first = add(res.first, 1);
        return res;
    }
    auto res = solve_init(n, 1, posB, posB);
    //cerr << add(f[n - 1], 1) << endl;
    res.first = add(res.first, add(f[n - 1], 1));
    return res;
}

void solve() {
    int n;
    cin >> n;
    vector<int> posA(n + 1), posB(n + 1);
    for (int i = 1; i <= n; ++i) {
        int x;
        cin >> x;
        posA[i] = x - 1;
    }
    for (int i = 1; i <= n; ++i) {
        int x;
        cin >> x;
        posB[i] = x - 1;
    }
    while (n >= 1 && posA[n] == posB[n]) {
        --n;
    }
    if (n == 0) {
        cout << "0\n";
        return;
    }
    int ans = 0;
    int pos = posA[1];
    for (int x = 2; x <= n - 1; ++x) {
        int next_pos = posA[x];
        if (pos == next_pos) continue;
        if (next_pos == 1) {
            ans = add(ans, d[x - 1]);
        } else if (pos == 1) {
            ans = add(ans, f[x - 1]);
        } else {
            ans = add(ans, e[x - 1]);
        }
        pos = next_pos;
    }
    //cerr << ans << endl;
    auto init = solve_init(n, posA[n], posB[n], pos);
    ans = add(ans, init.first);
    pos = init.second;
    --n;
    while (n >= 1) {
        //cout << pos << " " << ans << "\n";
        if (pos == posB[n]) {
            --n;
            continue;
        }
        if (posB[n] == 1) {
            //cout << "a\n";
            ans = add(ans, a[n]);
            pos = 2 - pos;
        } else if (pos == 1) {
            //cout << "c\n";
            ans = add(ans, c[n]);
            pos = 2 - posB[n];
        } else {
            //cout << "b\n";
            ans = add(ans, b[n]);
            pos = 2 - posB[n];
        }
        --n;
    }
    cout << ans << "\n";
}

signed main() {
    cout << fixed << setprecision(10);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    //freopen(TEST".in", "r", stdin);
    //freopen(TEST".out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    precalc();

    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}

/*
1
3 0 2 1
3 1 2 2
0 12
a
2 15
b
17
*/
