#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll maxn = ll(2e5)+5;
const ll mod = 988244353;

ll binpow(ll n, ll a) {
    if (a == 0) return 1;
    if (a%2) return n*binpow(n, a-1)%mod;
    ll t = binpow(n, a/2);
    return t*t%mod;
}

void solve() {
    int n;
    cin >> n;
    vector<int> h(n), p(n);
    for (int i = 0; i < n; i++) cin >> h[i];
    for (int i = 0; i < n; i++) cin >> p[i];
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) {
        a[i].first = p[i];
        a[i].second = h[i];
    }

    for (int i = 0; i < n; i++) {
        if (a[i].first < a[i].second) {
            cout << -1 << '\n';
            return;
        }; 
    }

    if (n == 1) {
        cout << a[0].first - a[0].second << '\n';
        return;
    }

    sort(a.begin(), a.end());
    for (int i = 1; i < n; i++) {
        if (a[i].first == a[i - 1].first) {
            if (a[i].second != a[i - 1].second) {
                cout << -1 << '\n';
                return;
            }
        }
        else {
            if (a[i].first - a[i].second < a[i - 1].first - a[i - 1].second) {
                cout << -1 << "\n";
                return;
            }
        }
    }

    cout << a.back().first - a.back().second << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    
    int tc;
    cin >> tc;
    while (tc--) solve();
    return 0;
}