#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll maxn = ll(2e5)+5;
const ll mod = 988244353;

ll binpow(ll n, ll a) {
    if (a == 0) return 1;
    if (a%2) return n*binpow(n, a-1)%mod;
    ll t = binpow(n, a/2);
    return t*t%mod;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<ll,ll>> s(n);
    for (int i=0;i<n;++i) cin >> s[i].second;
    for (int i=0;i<n;++i) cin >> s[i].first;
    sort(s.begin(), s.end());
    ll sm = 0;
    for (int i=0;i<n;++i) {
        if (s[i].first - sm < s[i].second) {
            cout << "-1\n";
            return;
        }
        sm += (s[i].first - s[i].second - sm);
    }
    cout << sm << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    
    int tc;
    cin >> tc;
    while (tc--) solve();
    return 0;
}