
#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <iomanip>
#include <string>
#include <random>
#include <typeinfo>
#include <map>
#include <set>
#include <cassert>
#include <queue>
#include <unordered_set>
#include <cstddef>
#include <unordered_map>
#include <array>
#include <ranges>

// #pragma GCC optimize("Ofast,unroll-loops")
// #pragma GCC target("avx2,popcnt,lzcnt,abm,bmi,bmi2")

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#ifdef DUDE
#define debug(x) cerr << #x << ": " << x << endl
#define debugvec(x) ({cerr << #x << ":\n"; for (const auto& e :x) cerr << '\t' << e << '\n';})
#else
#define debug(x) ;
#define debugvec(x) ;
#endif

using std::cout;
using std::cin;
using std::cerr;
using std::endl;
using std::ostream;
using std::istream;
using std::vector;
using std::pair;
using std::string;
using std::array;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using uint = unsigned int;
std::mt19937 rnd(459);

template<typename T>
istream &operator>>(istream &in, vector<T> &vec) {
    for (size_t i = 0; i < vec.size(); ++i) {
        in >> vec[i];
    }
    return in;
}

ostream &operator<<(ostream &out, const vector<bool> &vec) {
    for (bool i: vec) {
        if (i)
            out << '1';
        else
            out << '0';
    }
    return out;
}

template<typename T, typename U>
ostream &operator<<(ostream &out, const pair<T, U> &p) {
    out << p.first << ' ' << p.second;
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &vec) {
    char end_char = '\n';
    if constexpr (std::is_arithmetic_v<T>)
        end_char = ' ';
    for (const T &e: vec)
        out << e << end_char;
    return out;
}

template<typename T, size_t sz>
ostream &operator<<(ostream &out, const array<T, sz> &arr) {
    char end_char = '\n';
    if constexpr (std::is_arithmetic_v<T>)
        end_char = ' ';
    for (const T &e: arr)
        out << e << end_char;
    return out;
}

template<typename T>
bool mini(T &a, const T &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool maxi(T &a, const T &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

/*
 *
 */
void solve() {
    int n, M;
    cin >> n >> M;
    vector<string> keys(n);
    cin >> keys;
    int ans = 1e9 + 7;
    string sans = "NO";
    for (int letter = 0; letter < M; ++letter) {
        int steps = 0;
        string cur = "";
        for (string& s :keys) {
            int i = 0;
            while (i < s.size() && (s[i] - 'a') == letter) {
                cur += s[i];
                ++i;
            }
            if (i == s.size()) {
                steps = 1e9 + 7;
                break;
            }
            steps += i;
        }
        if (mini(ans, steps + 1)) {
            sans = cur;
            sans += ('a' + letter);
        }
    }
    cout << sans;
//    int n;
//    cin >> n;
//    vector<pair<int, int>> cur(n);
//    vector<pair<int, int>> old(n);
//    for (int i = 0; i < n; ++i) {
//        cin >> cur[i].first;
//        cur[i].second = i;
//    }
//
//    for (int i = 0; i < n; ++i) {
//        cin >> old[i].first;
//        old[i].second = i;
//    }
//    std::sort(all(old));
//    std::sort(all(cur));

}

signed main() {
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef DUDE
    freopen("./../inputf.in", "r", stdin);
    freopen("./../outputf.out", "w", stdout);
#endif

    // stress();

    // #define DUDE
    int test = 1;
#ifdef DUDE
    cin >> test;
#endif
    while (test--) {
        solve();
        cout << '\n';
    }
    return 0;
};