#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

void solve() {
    int n; cin >> n;
    vector<int> a(n);
    for (int &x : a) cin >> x;
    int s = 0, mn = 2e9;
    for (int x : a) {
        s += x;
        s %= 3;
        mn = min(mn, x);
    }
    int ans = 0;
    for (int i = 2; i >= 0; i--) {
        if ((i * n) % 3 == s) {
            int pos = mn;
            while (pos > 0 && pos % 3 != i) {
                pos--;
            }
            ans = max(ans, pos);
        }
    }
    cout << ans;
}



int main() {
    cin.tie(0)->sync_with_stdio(false);
    int tests = 1; cin >> tests;
    while (tests--) {
        solve();
        cout << '\n';
    }
}