#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

void solve() {
    int n; cin >> n;
    vector<int> a(n), b(n);
    for (int &x : a) cin >> x;
    for (int &x : b) cin >> x;
    vector<pair<int, int>> s(n);
    for (int i = 0; i < n; i++) s[i] = make_pair(b[i] - a[i], b[i]);
    sort(s.begin(), s.end());
    if (s[0].first < 0) {
        cout << -1;
        return;
    }
    for (int i = 1; i < n; i++) {
        if (s[i - 1].first != s[i].first && s[i].second - s[i].first < s[i - 1].second) {
            cout << -1;
            return;
        }
    }
    cout << s.back().first;
}

int main() {
    cin.tie(0)->sync_with_stdio(false);
    int tests = 1; cin >> tests;
    while (tests--) {
        solve();
        cout << '\n';
    }
}