#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

void solve() {
    int n, e; cin >> n >> e;
    vector<string> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];

    vector<int> cnt(e);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < a[i].size(); j++) {
            if (j > 0 && a[i][j - 1] != a[i][j]) break;
            if (j == a[i].size() - 1) cnt[a[i][j] - 'a'] = 1e9;
            cnt[a[i][j] - 'a']++;
        }
    }
    int best = 1e9, letter;
    for (int i = 0; i < e; i++) {
        if (cnt[i] < best) {
            best = cnt[i];
            letter = i;
        }
    }
    if (best == 1e9) {
        cout << "NO";
        return;
    }
    for (int i = 0; i <= best; i++) cout << char(letter + 'a');
}



int main() {
    cin.tie(0)->sync_with_stdio(false);
    int tests = 1; //cin >> tests;
    while (tests--) {
        solve();
        cout << '\n';
    }
}