//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC optimize("O3,unroll-loops")
//#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt"
//#pragma GCC target("avx2,avx,sse2,sse")

#define _GLIBCXX_DEBUG 1

#include <bits/stdc++.h>
using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define Sz(x) ((int)(x).size())
#define rep(i, a, b) for(int i = a; i < (b); ++i)
using ld = long double;
[[maybe_unused]] constexpr static int INF = (int) 1e18+10+300+5251+14154;
using pii = pair<int, int>;
using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vpi = vector<pii>;
#ifdef LOCAL
void debugPrint(long long integer) {cerr << integer;}
void debugPrint(float kek) {cerr << kek;}
void debugPrint(double kek) {cerr << kek;}
void debugPrint(std::string s) {cerr << "\"" << s << "\"";}
void debugPrint(const char* s) {cerr << "\"" << s << "\"";}
void debugPrint(bool b) {cerr << (b ? "true" : "false");}
void debugPrint(char  c) {cerr << "\'" << c << "\'";}
template <typename F, typename S>
void debugPrint(const pair<F, S> & p) { cerr << "{"; debugPrint(p.first); cerr << ", "; debugPrint(p.second); cerr << "}";}
template<typename T>
void debugPrint(complex<T> c) { cerr << "{"; debugPrint(c.real()); cerr << ", "; debugPrint(c.imag()); cerr << "}";}
template <template <typename> class Container, typename T>
void debugPrint(Container<T>& container) {
    cerr << "{";
    for (auto it = container.begin(); it != container.end(); ++it) {
        if (it == container.begin()) {
            debugPrint(*it);
        } else {
            cerr << ", ";
            debugPrint(*it);
        }
    }
    cerr << "}";
}
void debugPrint() {}
template <typename Head, typename... Tail>
void debugPrint(Head head, Tail... tail) {
    debugPrint(head); if (sizeof...(tail) != 0) {
        cerr << ", ";
    }
    debugPrint(tail...);
}
#endif
#ifdef LOCAL
#define debug(x...) cerr << "[" << #x << "] = ["; debugPrint(x); cerr << "]\n";
#else
#define debug(x...) 52
#endif

void solve() {
    const int MOD = 998244353;
    int n, m, k;
    cin >> n >> m >> k;
    string kek; cin >> kek;

    auto good = [&] (string s, string w) {
        for (int i = 0; i + Sz(w) - 1 < Sz(s); i++) {
            if (s.substr(i, Sz(w)) == w) {
                return false;
            }
        }
        return true;
    };
    auto calc_dp = [&] (const string& w) -> vvi {
        vi ans(101, 0);
        vvi dp(101, vi(1 << Sz(w), 0));

        for (int len = 0; len < Sz(w); len++) {
            ans[len] = (1ll << len);
        }
        for (int len = Sz(w); len <= 7; len++) {
            for (int i = 0; i < (1LL << len); i++) {
                string s;
                for (int j = 0; j < len; j++) {
                    if (i & (1 << j)) {
                        s+='1';
                    }else{
                        s+='0';
                    }
                }
//                if (good(s, w)) {
//                    debug("goood");
//                }
                dp[len][i % (1<<Sz(w))] += good(s, w);
            }
            ans[len] = accumulate(all(dp[len]), 0LL) % MOD;
        }

        debug(ans[Sz(w)]);

        for (int len = 8; len <= 100; len++) {

            for (int mask1 = 0; mask1 < (1<<Sz(w)); mask1++) {
                for (int mask2 = 0; mask2 < (1<<Sz(w)); mask2++) {
                    string s;
                    for (int j = 0; j < Sz(w); j++) s+=(char)('0' + (mask1 & (1 << j)));
                    for (int j = 0; j < Sz(w); j++) s+=(char)('0' + (mask2 & (1 << j)));

                    if (!good(s, w)) continue;
//                    debug(mask1, mask2);
                    dp[len][mask2] += dp[len - Sz(w)][mask1];
                    dp[len][mask2] %= MOD;
                }
            }

            ans[len] = accumulate(all(dp[len]), 0LL) % MOD;
        }
        return dp;
    };

    auto dp = calc_dp(kek);
//    for (int i = 0; i <= 0; i++) {
//        for (int j = 0; j < (1<<Sz(kek)); j++) {
//            dp[i][j] = 1;
//        }
//    }

//    for (int i = 0; i < 10; i++) {
//        cout << dp[i] << " ";
//    }

    vector<int> pow(1001, 1);
    for (int i = 1; i <= 1000; i++) {
        pow[i] = (2 * pow[i - 1]) % MOD;
    }

    int ans = 0;

    auto got = [&] (int e) -> int {
        if (e < Sz(kek)) return (1 << e);

        int tiktok = 0;
        for (int mask = 0; mask < (1 << Sz(kek)); mask++) {
            string s;
            for (int j = 0; j < Sz(kek); j++) s += (char) ('0' + (mask & (1 << j)));
            s += kek;
            s.pop_back();
            if (good(s, kek)) {
                tiktok+=dp[e - Sz(kek)][mask];
            }
        }
        return tiktok;
    };
    for (int i = 0; i <= 10; i++) {
        debug(i, got(i));
    }
    for (int e1 = Sz(kek); e1 <= n; e1++) {
        for (int e2 = Sz(kek); e2 <= m; e2++) {
            int anothers1 = n - e1;
            int anothers2 = m - e2;
            int mult = pow[anothers1] * pow[anothers2] % MOD;

            auto t1 = got(e1);
            auto t2 = got(e2);
            int cur = t1 * t2 % MOD;
            cur *= mult;
            cur %= MOD;
            ans+=cur;
            ans %= MOD;
        }
    }
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("C:\\work\\vologda\\input.txt", "r", stdin);
#endif

//    solve();
    int n;
    cin >> n;
    int e;
    cin >> e;
    vector<string> ss(n);
    for (auto& s: ss) {
        cin >> s;
    }
    char ans = '0';
    int mnlen = 100000000;
    for (char c = 'a'; c < 'a' + e; ++c) {
        int cur = 0;
        bool mega_ok = true;
        for (auto& s: ss) {
            bool ok = false;
            for (auto& symb: s) {
                if (symb == c) {
                    ++cur;
                } else {
                    ok = true;
                    break;
                }
            }
            mega_ok &= ok;
        }
        if (mega_ok && mnlen > cur) {
            ans = c;
            mnlen = cur;
        }
    }
    if (ans == '0') {
        cout << "NO" << endl;
        return 0;
    }
    string anss;
    for (int i = 0; i < mnlen + 1; ++i) {
        anss += ans;
    }
    cout << anss << endl;

}