#include<iostream>
#include<string>
#include<vector>
#include<set>
#include<algorithm>
#include<cassert>

using namespace std;

#define x first
#define y second

typedef long long ll;

int solve() {
    int n;
    cin >> n;
    struct T {
        ll x, cnt;
        bool sec;
    };

    vector<T> a(n);
    ll tot[2] = {0, 0};
    for (auto &[x, cnt, sec] : a) {
        cin >> x >> cnt;
        char c;
        cin >> c;
        sec = c == 'B';
        tot[sec] += cnt;
    }
    int last = 0;
    for (int i = n - 1; i >= 0; i--) {
        if (!a[i].sec) {
            last = a[i].x;
            break;
        }
    }

    if (tot[0] == tot[1]) {
        return cout << "Draw " << last << " +\n", 0;
    }

    bool win_player = tot[1] > tot[0];

    ll alive = 0;
    ll extra = 0;

    bool draw = 0;
    bool p = a[n - 1].sec;

    ll moves[2] = {0, 0};
    vector<T> stck;

    for (int i = n - 1; i >= 0; i--) {
        while (!stck.empty() && stck.back().sec != a[i].sec && a[i].cnt > 0) {
            ll need = min(a[i].cnt, stck.back().cnt);
            stck.back().cnt -= need;
            a[i].cnt -= need;
            ll waste = (stck.back().first - a[i].x) * need;
            moves[a[i].sec] += waste;
            if (a[i].sec == win_player) {
                if (moves[win_player] - (int)(win_player == 0) > moves[win_player ^ 1]) {
                    draw = 1;
                    break;
                }
            }
            if (!stck.back().cnt) {
                stck.pop_back();
            }
        }
        if (draw) {
            break;
        }
        if (a[i].cnt) {
            stck.push_back(a[i]);
        }
    }

    if (draw) {
        return cout << "Draw " << last << " +\n", 0;
    }
    if (win_player) {
        return cout << "Second\n", 0;
    } else {
        return cout << "First " << last << " +\n", 0;
    }

    return 0;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}