#include <bits/stdc++.h>
//#include "optimization.h"

using namespace std;

#define ll long long
#define uint unsigned int
#define ld long double
#define X first
#define Y second
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define vii vector<pair<int, int>>
#define vvi vector<vector<int>>
#define INF INT_MAX
#define int long long



const int MAXN = 1e4;
const int ALPHA = 26;
const int p = 239;

signed main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);
//    freopen("input.txt", "r", stdin);

    int n, e;
    cin >> n >> e;

    vector<string> numbers(n);

    for (auto &it : numbers) {
        cin >> it;
    }

    vector<int> cur(n, 0);

    queue<pair<pair<vector<int>, int>, int>> q;
    map<int, unordered_set<int>> hashes;
    map<int, vector<int>> hash_to_vertex;
    set<vector<int>> visited;
    unordered_set<int> hash_visited;
    unordered_map<int, int> hash_to_len;
    map<vector<int>, int> prev;
    q.push({{cur, 0}, 0});
    prev[cur] = -1;
    visited.insert(cur);
    hash_to_vertex[0] = cur;
    hash_to_len[0] = 0;
    while(!q.empty()) {
        auto v = q.front().first.first;
        int hash = q.front().first.second;
        int depth = q.front().second;
        q.pop();
        for (int i = 0; i < n; i++) {
            int new_hash = hash * p + numbers[i][v[i]];
            hashes[hash].insert(numbers[i][v[i]]);
            v[i]++;
            v[i] %= numbers[i].size();
            if (visited.find(v) != visited.end()) {
                continue;
            }
            visited.insert(v);
            if (hash_visited.find(new_hash) == hash_visited.end()) {
                hash_to_len[new_hash] = depth + 1;
                hash_to_vertex[new_hash] = v;
            }
            hash_visited.insert(new_hash);
            q.push({{v, new_hash}, depth + 1});
            prev[v] = i;

            v[i]--;
            v[i] += numbers[i].size();
            v[i] %= numbers[i].size();
        }
    }

    string ans;
    int hash_ans = -1;
    int min_len = 1e9;
    char ans_char = 0;
    for (auto el: hashes) {
        auto &s = el.second;
        for (int i = 0; i < e; i++) {
            if (s.find('a' + i) == s.end()) {
                if (min_len > hash_to_len[el.first]) {
                    min_len = hash_to_len[el.first];
                    hash_ans = el.first;
                    ans_char = 'a' + i;
                }
            }
        }
    }

    if (min_len == 1e9) {
        cout << "NO\n";
        return 0;
    }
    //cout << hash_ans << endl;
    ans.push_back(ans_char);
    auto v = hash_to_vertex[hash_ans];
    while (prev[v] != -1) {
        int j = prev[v];
        v[j]--;
        v[j] += numbers[j].size();
        v[j] %= numbers[j].size();
        ans.push_back(numbers[j][v[j]]);
    }

    reverse(all(ans));
    cout << ans;
}