#include <bits/stdc++.h>
using namespace ::std;

#define int long long
#define ll long long
#define YES "YES\n"
#define NO "NO\n"

vector<vector<int>> g;
vector<int> balance;

void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n + 1, {});
    balance.assign(n, 0);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a;--b;
        ++balance[a];
        --balance[b];
        g[a].push_back(b);
    }
    vector<pair<int, int>> b;
    for (int i = 0; i < n; ++i) {
        b.push_back({balance[i], i});
    }
    sort(b.begin(), b.end());
    vector<int> top;
    for (int i = 0; i < n; ++i) {
        top.push_back(b[i].second);
    }
    vector<int> pos(n);
    for (int i = 0; i < n; ++i) {
        pos[top[i]] = i;
    }

    int cnt = 0;

    for (int i = 0; i < n; ++i) {
        for (auto u : g[i]) {
            if (pos[i] < pos[u]) ++cnt;
        }
    }
    if (cnt >= (m + 1) / 2) {
        for (auto i : top) cout << i + 1 << " ";
        cout << "\n";
    } else {
        reverse(top.begin(), top.end());
        for (auto i : top) cout << i + 1 << " ";
        cout << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int tt = 1;
    cin >> tt;

    while (tt--) {
        solve();
    }
}
