#include <bits/stdc++.h>

using namespace std;

void solve() {
  int n, m, k;
  cin >> n >> m >> k;
  vector<vector<int>> g(n);
  vector<int> using_colors(n, k);
  for (int i = 0; i < m; i++) {
    int a, b;
    cin >> a >> b;
    g[a - 1].push_back(b - 1);
    g[b - 1].push_back(a - 1);
  }
  for (int i = 0; i < n; i++) {
    g[i].push_back((i + 1) % n);
    g[(i + 1) % n].push_back(i);
  }
  long long int ans = 1;
  const int MOD = 998244353;
  for (int i = 0; i < n; i++) {
    ans = (ans * using_colors[i]) % MOD;
    for (int j = 0; j < g[i].size(); j++) {
      using_colors[g[i][j]]--;
    }
  }
  cout << ans<<"\n";
}

int main() {
  int t;
  cin >> t;
  while (t--) {
    solve();
  }
}
