#include<iostream>
#include<iomanip>
#include<string>
#include<vector>
#include<map>
#include<unordered_map>
#include<unordered_set>
#include<queue>
#include<deque>
#include<algorithm>
#include<cmath>
#include<cctype>
#include<fstream>
#include<ios>
#include<bitset>
#include<numbers>
#include <random>
#include <set>

using namespace std;
#define sort(a) sort(a.begin(), a.end())
#define reverse(a) reverse(a.begin(), a.end())
#define all(a) a.begin(), a.end()
#define pb push_back
mt19937 rnd(time(nullptr));

typedef long long ll;

const int MAXN = 2E5 + 11;
ll n, a[MAXN], b[MAXN];
ll k[MAXN];

ll findMin(int l, int r) {
    ll res = k[l];
    for(int i = l; i <= r; ++i)
        res = min(res, k[i]);
    return res;
}

void solve() {
    cin >> n;
    fill(k + 1, k + n + 1, 0);
    for(int i = 1; i <= n; ++i) {
        cin >> a[i];
        b[i] = a[i] - a[i - 1];
    }
    b[1] = a[1] - a[n];

    if(n == 2) {
        int diff = abs(a[1] - a[2]);
        if(min(a[1], a[2]) - diff <= 0) {
            cout << "0\n";
        } else {
            cout << min(a[1], a[2]) - diff << "\n";
        }
        return;
    }

    for(int i = 1; i <= n; ++i) {
        if(n - i + 1 == 3) {
            k[i + 1] += b[i + 1];
            k[i + 2] -= b[i + 1];
            break;
        }

        if(b[i] > 0) {
            int l = i + 1;
            int r = n - 1;
            k[l] += b[i];
            k[r + 1] -= b[i];

            b[i + 1] -= 2 * b[i];
            b[n - 1] += b[i];
            b[n] += 2 * b[i];
            b[i] = 0;
        } else if(b[i] < 0) {
            k[n] += -b[i];
            k[1] += -b[i];
            k[i + 1] -= -b[i];

            b[n - 1] -= -b[i];
            b[n] -= 2 * (-b[i]);
            b[i + 1] += 2 * (-b[i]);
            b[i] = 0;
        }
    }

    for(int i = 2; i <= n; i++)
        k[i] += k[i - 1];


    int mn = findMin(1, n);

    for(int i = 1; i <= n; ++i) {
        a[i] -= 2 * (k[i] - mn);
        int id = (i == 1 ? n : i - 1);
        a[id] -= k[i] - mn;

        if(a[id] <= 0 || a[i] <= 0) {
            cout << "0\n";
            return;
        }
    }
//    for(int i = 1; i <= n; ++i)
//        cout << a[i] << " ";
//    cout << "\n";
//    for(int i = 1; i <= n; ++i)
//        cout << k[i] << " ";
    for(int i = 2; i <= n; ++i)
        if(a[i] != a[i - 1]) {
            cout << "0\n";
            return;
        }
    cout << a[1] << "\n";
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while(t--) {
        solve();
    }
}