#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef vector<int> vi;

#define pb push_back
#define forn(i, n) for(ll i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()

void solve(){
    int n, m;
    cin >> n >> m;
    
    vector<vector<int>> a(n);
    forn(i, m) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        a[x].push_back(y);
    }

    int T = 0;
    vector<int> used(n);

    vector<int> pos(n);
    vector<int> comp;

    function<void(int)> dfs = [&](int v) {
        used[v] = 1;
        pos[v] = comp.size();
        comp.push_back(v);
        
        for (auto u : a[v]) {
            if (!used[u]) {
                dfs(u);
            }
        }
    };

    vector<int> ans;

    forn(i, n) {
        if (!used[i]) {
            comp.clear();
            dfs(i);

            int all_cnt = 0; 
            int fwd = 0;

            for (auto v : comp) {
                all_cnt += a[v].size();
                for (auto u : a[v]) {
                    if (pos[u] > pos[v]) {
                        ++fwd;
                    }
                }
            }

            // cout << fwd << " " << all_cnt << endl;
            if (fwd < (all_cnt + 1) / 2) {
                reverse(all(comp));
            }

            ans.insert(ans.end(), all(comp));
        }
    }

    forn(i, n) {
         cout << ans[i] + 1 << " ";
    }
    cout << "\n";
}

int main(){
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    int t = 1;
    cin >> t;
    while (t--)
    {
        solve();
    }
}