#include <bits/stdc++.h>

using namespace std;

void solve(){
    int n, m;
    cin >> n >> m;
    vector <int> gin[n], gout[n];
    vector <int> vin(n, 0), vout(n, 0);
    priority_queue <pair <int, int>> pq; // max out - in
    for(int i = 0; i < m; ++i){
        int u, v;
        cin >> u >> v;
        u--, v--;
        gout[u].push_back(v);
        gin[v].push_back(u);
    }
    for(int i = 0; i < n; ++i){
        vin[i] = gin[i].size();
        vout[i] = gout[i].size();
        pq.push({vout[i] - vin[i], i});
    }
    vector <int> ans;
    vector <bool> used(n, false);
    while(!pq.empty()){
        auto p = pq.top();
        //cout << p.first << ' ' << p.second << '\n';
        pq.pop();
        int diff = p.first, v = p.second;
        if(diff != vout[v] - vin[v] || used[v])
            continue;
        used[v] = true;
        ans.push_back(v);
        for(auto u:gin[v]){
            if(!used[u]) {
                vout[u]--;
                pq.push({vout[u] - vin[u], u});
            }
        }
        for(auto u:gout[v]){
            if(!used[u]) {
                vin[u]--;
                pq.push({vout[u] - vin[u], u});
            }
        }

    }
    for(auto v:ans)
        cout << v+1 << ' ';
    cout << '\n';
}

int main() {
    int t;
    cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
