#include <bits/stdc++.h>


using namespace std;

const int MOD = 998244353;
const int SZ4 = 1 << ((1 << 4));
const int SZ3 = 1 << ((1 << 3));
const int SZ2 = 1 << ((1 << 2));
int dp4[105][SZ4][2][2][2];
int dp3[105][SZ3][2][2];
int dp2[105][SZ2][2];
int sum4[105][SZ4], sum3[105][SZ3], sum2[105][SZ2];

int get_bits(int x1) {
    return 1 << x1;
}

int get_bits(int x1, int x2) {
    return 1 << (x1 * 2 + x2);
}

int get_bits(int x1, int x2, int x3) {
    return 1 << (x1 * 4 + x2 * 2 + x3);
}

int get_bits(int x1, int x2, int x3, int x4) {
    return 1 << (x1 * 8 + x2 * 4 + x3 * 2 + x4);
}

int upd_mask(int mask, int x1, int x2, int x3, int x4) {
    return mask | get_bits(x1, x2, x3, x4);
}

void solve() {
    int n, m, k; cin >> n >> m >> k;
    if (n == m && k == n) {
        cout << "1\n";
        return;
    }
    if (n > m) swap(n, m);
    for (int x1 = 0; x1 < 2; ++x1) {
        for (int x2 = 0; x2 < 2; ++x2) {
            dp2[2][get_bits(x1, x2)][x2] = 1;
            for (int x3 = 0; x3 < 2; ++x3) {
                dp3[3][get_bits(x1, x2, x3)][x2][x3] = 1;
                for (int x4 = 0; x4 < 2; ++x4) {
                    dp4[4][get_bits(x1, x2, x3, x4)][x2][x3][x4] = 1;
                }
            }
        }
    }
    for (int i = 4; i < max(n, m); ++i) {
        for (int mask = 0; mask < SZ4; ++mask) {
            for (int x1 = 0; x1 < 2; ++x1) {
                for (int x2 = 0; x2 < 2; ++x2) {
                    for (int x3 = 0; x3 < 2; ++x3) {
                        if (dp4[i][mask][x1][x2][x3] == 0)
                            continue;
                        for (int x4 = 0; x4 < 2; ++x4) {
                            int &to = dp4[i + 1][mask | get_bits(x1, x2, x3, x4)][x2][x3][x4];
                            to = (to + dp4[i][mask][x1][x2][x3]) % MOD;
                        }
                    }
                }
            }
        }
    }

    for (int i = 3; i < max(n, m); ++i) {
        for (int mask = 0; mask < SZ3; ++mask) {
            for (int x1 = 0; x1 < 2; ++x1) {
                for (int x2 = 0; x2 < 2; ++x2) {
                    if (dp3[i][mask][x1][x2] == 0)
                        continue;
                    for (int x3 = 0; x3 < 2; ++x3) {
                        int &to = dp3[i + 1][mask | get_bits(x1, x2, x3)][x2][x3];
                        to = (to + dp3[i][mask][x1][x2]) % MOD;
                    }
                }
            }
        }
    }

    for (int i = 2; i < max(n, m); ++i) {
        for (int mask = 0; mask < SZ2; ++mask) {
            for (int x1 = 0; x1 < 2; ++x1) {
                if (dp2[i][mask][x1] == 0)
                    continue;
                for (int x2 = 0; x2 < 2; ++x2) {
                    int &to = dp2[i + 1][mask | get_bits(x1, x2)][x2];
                    to = (to + dp2[i][mask][x1]) % MOD;
                }
            }
        }
    }

    for (int i = 0; i < 105; ++i) {
        for (int mask = 0; mask < SZ4; ++mask) {
            for (int x1 = 0; x1 < 2; ++x1) {
                for (int x2 = 0; x2 < 2; ++x2) {
                    for (int x3 = 0; x3 < 2; ++x3) {
                        sum4[i][mask] = (sum4[i][mask] + dp4[i][mask][x1][x2][x3]) % MOD;
                    }
                }
            }
        }
    }

    for (int i = 0; i < 105; ++i) {
        for (int mask = 0; mask < SZ3; ++mask) {
            for (int x1 = 0; x1 < 2; ++x1) {
                for (int x2 = 0; x2 < 2; ++x2) {
                    sum3[i][mask] = (sum3[i][mask] + dp3[i][mask][x1][x2]) % MOD;
                }
            }
        }
    }

    for (int i = 0; i < 105; ++i) {
        for (int mask = 0; mask < SZ2; ++mask) {
            for (int x1 = 0; x1 < 2; ++x1) {
                sum2[i][mask] = (sum2[i][mask] + dp2[i][mask][x1]) % MOD;
            }
        }
    }

    string s; cin >> s;
    int res = 0;
    if (k == 3) {
        int val = 4 * (s[0] - '0') + 2 * (s[1] - '0') + (s[2] - '0');
        int w1 = val << 1;
        int w2 = (val << 1) | 1;
        int w3 = val | (1 << 3);
        int w4 = val | (0 << 3);
        if (n == k) {
            int qw = 0;
            for (int mask = 0; mask < SZ3; ++mask) {
                if (mask >> val & 1)
                    qw = (qw + sum3[m][mask]) % MOD;
            }
            cout << qw;
            return;
        }
        for (int mask1 = 0; mask1 < SZ4; ++mask1) {
            for (int mask2 = 0; mask2 < SZ4; ++mask2) {
                int x = mask1 & mask2;
                if (x != 0) continue;
                bool b1 = (mask1 >> w1 & 1) || (mask1 >> w2 & 1) || (mask1 >> w3 & 1) || (mask1 >> w4 & 1);
                bool b2 = (mask2 >> w1 & 1) || (mask2 >> w2 & 1) || (mask2 >> w3 & 1) || (mask2 >> w4 & 1);
                if (b1 && b2) {
                    res = (res + sum4[n][mask1] * 1ll * sum4[m][mask2] % MOD) % MOD;
                }
            }
        }
    } else if (k == 2) {
        int val = 2 * (s[0] - '0') + (s[1] - '0');
        int w1 = val << 1;
        int w2 = (val << 1) | 1;
        int w3 = val | (1 << 2);
        int w4 = val | (0 << 2);
        if (n == k) {
            int qw = 0;
            for (int mask = 0; mask < SZ2; ++mask) {
                if (mask >> val & 1)
                    qw = (qw + sum2[m][mask]) % MOD;
            }
            cout << qw;
            return;
        }
        for (int mask1 = 0; mask1 < SZ3; ++mask1) {
            for (int mask2 = 0; mask2 < SZ3; ++mask2) {
                int x = mask1 & mask2;
                if (x != 0) continue;
                bool b1 = (mask1 >> w1 & 1) || (mask1 >> w2 & 1) || (mask1 >> w3 & 1) || (mask1 >> w4 & 1);
                bool b2 = (mask2 >> w1 & 1) || (mask2 >> w2 & 1) || (mask2 >> w3 & 1) || (mask2 >> w4 & 1);
                if (b1 && b2) {
                    res = (res + sum3[n][mask1] * 1ll * sum3[m][mask2] % MOD) % MOD;
                }
            }
        }
    } else {
        assert(k == 1);
        int val = (s[0] - '0');
        int w1 = val << 1;
        int w2 = (val << 1) | 1;
        int w3 = val | (1 << 1);
        int w4 = val | (0 << 1);
        if (n == k) {
            int kek = 1;
            for (int w=  0; w < m; ++w) kek = kek * 2ll % MOD;
            cout << (kek - 1 + MOD) % MOD << "\n";
            return;
        }
        for (int mask1 = 0; mask1 < SZ2; ++mask1) {
            for (int mask2 = 0; mask2 < SZ2; ++mask2) {
                int x = mask1 & mask2;
                if (x != 0) continue;
                bool b1 = (mask1 >> w1 & 1) || (mask1 >> w2 & 1) || (mask1 >> w3 & 1) || (mask1 >> w4 & 1);
                bool b2 = (mask2 >> w1 & 1) || (mask2 >> w2 & 1) || (mask2 >> w3 & 1) || (mask2 >> w4 & 1);
                if (b1 && b2) {
                    res = (res + sum2[n][mask1] * 1ll * sum2[m][mask2] % MOD) % MOD;
                }
            }
        }
    }
    cout << res << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}