#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define f first
#define s second
//#define x first
//#define y second
#define pb push_back
#define _ << ' ' <<
#define TEST ""
#define all(x) x.begin(), x.end()
#define mp make_pair
#define sz(x) (int)x.size()
//#define cerr if(0) cerr
//#define int long long
#define Time() (ld)clock() / CLOCKS_PER_SEC

//#pragma GCC optimize ("O3")
//#pragma GCC optimize ("Ofast")
//#pragma GCC target ("sse,sse2,sse3,sse4,avx,avx2")
//#pragma comment(linker, "/STACK:160777216")

//before loops:
//#pragma unroll(3)

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;

#ifdef LOCAL
    #define cerr cout
#else
    #define cerr if(0) cerr
#endif

//template<typename T>
//using orderd_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T1, typename T2>
__attribute__((always_inline)) common_type_t<T1, T2> min(const T1 &a, const T2 &b) {
    return a < b ? a : b;
}

template<typename T3, typename T4>
__attribute__((always_inline)) common_type_t<T3, T4> max(const T3 &a, const T4 &b) {
    return a > b ? a : b;
}

template<typename T>
using normal_queue = priority_queue<T, vector<T>, greater<T> >;

const int MAXN = 105, MAXK = 3, MAXLEN = (1 << (MAXK + 1)), MAXM = (1 << MAXLEN), MOD = 998244353;

int k;
int len_mask;
int max_mask;

int dp[MAXN][MAXLEN][MAXM];
int sumdp[MAXN][MAXM];

int go[MAXM][2];
bool good[MAXM];

int add(int x, int y) {
    return (x + y < MOD ? x + y : x + y - MOD);
}

int dec(int x, int y) {
    return (x - y < 0 ? x - y + MOD : x - y);
}

int mul(int x, int y) {
    return 1ll * x * y % MOD;
}

int get_go(int last, int c) {
    return ((last << 1) & (len_mask - 1)) | c;
}

void calc_sumdp(int n) {
    for (int mask = 0; mask < len_mask; mask++) {
        dp[k + 1][mask][(1 << mask)] = 1;
        sumdp[k + 1][(1 << mask)] = 1;
    }
    for (int len = k + 1; len < n; len++) {
        for (int last = 0; last < len_mask; last++) {
            for (int c = 0; c < 2; c++) {
                int nlast = get_go(last, c);
                for (int mask = 0; mask < MAXM; mask++) {
                    int nmask = (mask | (1 << nlast));
                    dp[len + 1][nlast][nmask] = add(dp[len + 1][nlast][nmask], dp[len][last][mask]);
                    sumdp[len + 1][nmask] = add(sumdp[len + 1][nmask], dp[len][last][mask]);
                }
            }
        }

    }
}

void calc_good(int w) {
    for (int mask = 0; mask < (1 << len_mask); mask++) {
        if (((mask >> (w << 1)) & 1) || //w0
            ((mask >> ((w << 1) | 1)) & 1) || //w1
            ((mask >> (w | (1 << k))) & 1) || //1w
            ((mask >> w) & 1) //0w
        )
            good[mask] = 1;
    }
}

string get_bits(int mask) {
    string res;
    while (sz(res) < len_mask) {
        res += '0' + (mask & 1);
        mask = (mask >> 1);
    }
    reverse(all(res));
    return res;
}

void solve() {
    int n, m;
    cin >> n >> m >> k;
    string tmp; cin >> tmp;
    int w = 0;
    for (char c : tmp) {
        w = (w << 1) + c - '0';
    }
    if (n < m)
        swap(n, m);

    //n >= m

    if (n == m && m == k) {
        cout << 1;
        return;
    }

    len_mask = (1 << (k + 1));
    max_mask = (1 << len_mask) - 1;

    calc_sumdp(n);
    calc_good(w);

    int ans = 0;
    if (m == k) {
        for (int mask = 0; mask < (1 << len_mask); mask++) {
            if (good[mask]) ans = add(ans, sumdp[n][mask]);
        }
        cout << ans << '\n';
        return;
    }
    for (int mask = 0; mask < (1 << len_mask); mask++) {
        for (int nmask = mask; nmask > 0; nmask = (nmask - 1) & mask) {
            int real_mask = (max_mask ^ mask);

            if (good[real_mask] && good[nmask] && sumdp[n][real_mask] != 0 && sumdp[m][nmask] != 0) {
                ans = add(ans, mul(sumdp[n][real_mask], sumdp[m][nmask]));
            }
        }
    }
    cout << ans;
}

signed main() {
    cout << fixed << setprecision(10);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    //freopen(TEST".in", "r", stdin);
    //freopen(TEST".out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}

/*
00000010 1
00000011 2
00000101 1
00000110 1
00001001 1
00001010 1
00001010 00100000 1 1
00001010 00000100 1 1
00001001 00100000 1 1
00001001 00000100 1 1
00001001 00000010 1 1
00000110 00100000 1 1
00000110 00001000 1 1
00000101 00100000 1 1
00000101 00001000 1 1
00000101 00000010 1 1
00000011 00100000 2 1
00000011 00001000 2 1
00000011 00000100 2 1
00000010 00100000 1 1
00000010 00001000 1 1
00000010 00000100 1 1
19
*/
