#include <iostream>
#include <vector>

#include <algorithm>
using namespace std;

int main() {
	int n;
	cin >> n;

	for (int i = 0; i < n; ++i) {

		int m;
		int val = 0;
		cin >> m;
		vector<pair<int, int>> v(m);

		for (int j = 0; j < m; ++j)
			cin >> v[j].first;

		for (int j = 0; j < m; ++j) 
			cin >> v[j].second;

		std::sort(v.begin(), v.end(), [](auto a, auto b) {
			if (a.second < b.second)
				return true;
			else if (a.second > b.second)
				return false;
			else
				return a.first < b.first;
			});

		vector<int> diff(m);
		for (int j = 0; j < m; ++j)
			diff[j] = v[j].second - v[j].first;

		for (int j = 1; j < m; ++j)
			if (diff[j] < diff[j - 1] || diff[j] < 0 || diff[j - 1] < 0)
				val = -1;

		if (!val)
			cout << diff[m - 1] << '\n';
		else
			cout << val << '\n';
	}

	return 0;
}
