#include <iostream>
#include <algorithm>
#include <functional>
#include <chrono>
#include <random>
#include <fstream>
#include <string>
#define fir first
#define sec second
#define ll long long
#define int ll
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) int(x.size())
#define pii pair <int, int>
#define pll pair <ll, ll>
#define vec vector
typedef std::vector<int> veci;
#define $ '\n'
using namespace std;

const int mod = 1e9 + 7;
const int inf = 2e9 + 7;
const ll INF = 2e18 + 7;

mt19937_64 gen(chrono::high_resolution_clock::now().time_since_epoch().count());
int random(int l, int r) {
    if (l > r) swap(l, r);
    return l + (gen() % (r - l + 1));
}

template <typename T>
ostream& operator << (ostream& os, const vector <T>& v) {
    for (const T& to: v) {
        os << to << ' ';
    }
    return os;
}

template <typename T>
istream& operator >> (istream& is, vector <T>& v) {
    for (T& to: v) {
        is >> to;
    }
    return is;
}
using prii = pair<int,int>;
void solve() {
    int n;
    cin >> n;
    int e;
    cin >> e;
    vector <string> s(n);
    cin >> s;
    for (int len = 1; len <= 1000; len++) {
        for (char let = 'a'; let <= char('a' + (e - 1)); let++) {
            vector <int> uk(n);
            bool ok = false;
            int cur = 0;
            for (int i = 0; i < n; i++) {
                int j = 0;
                while (j < s[i].size() && s[i][j] == let) {
                    cur++;
                    if (cur == len) break;
                    j++;
                }
                if (j == s[i].size()) cur = len;
                ok |= (cur == len);
            }
            if (!ok) {
                for (int i = 0; i < len; i++) {
                    cout << let;
                }
                cout << endl;
                return;
            }
        }
    }
    cout << "NO" << endl;
    return;
}
/*
4
3 2 4 2
5 3 6 2
1
10
100000
5
1 2 3 4 5
1 2 3 4 5
3
1 4 6
4 1 8
 */

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
        cout.flush();
    }
    return 0;
}