#include <bits/stdc++.h>

#define int long long
using namespace std;


const int MOD = 998244353;


int add(int x, int y) {
    x += y;
    if (x >= MOD) return x - MOD;
    return x;
}
int sub(int x, int y) {
    x -= y;
    if (x < 0) return x + MOD;
    return x;
}
int mult(int x, int y) {
    return (x * y) % MOD;
}
int binPow(int x, int p) {
    if (p == 0) return 1;
    if (p == 2 || (p & 1)) return mult(x, binPow(x, p - 1));
    return binPow(binPow(x, p / 2), 2);
}
int modRev(int x) {
    return binPow(x, MOD - 2);
}

int get_num(const vector<int>& st, int last, bool is_rev){
    int sum = 0;
    int cur = st[last];
    if (is_rev) cur = 2-cur;
    if (last == 0){
        return cur;
    }
    sum = mult(binPow(3, last), cur);
    sum = add(sum, get_num(st, last-1, (cur == 1) & is_rev));
    return sum;
}

bool cmp(const vector<int>& st, const vector<int>& st2, int last, bool is_rev){
    if (st[last] < st2[last]){
        return !is_rev;
    }
    if (st[last] > st2[last]){
        return is_rev;
    }
    if (last == 0){
        return true;
    }
    return cmp(st, st2, last-1, (st[last] == 1) & is_rev);
}
void solve() {
    int n; cin >> n;
    vector<int> start(n);
    vector<int> finish(n);
    for (int i = 0; i< n; i++){
        cin >> start[i];
        start[i]--;
    }
    for (int i = 0; i< n; i++){
        cin >> finish[i];
        finish[i]--;
    }
    int num_s = get_num(start, n-1, 0);
    int num_f = get_num(finish,n-1, 0);
    if (cmp(start, finish, n-1, 0)){
        swap(num_s, num_f);
    }
    int ans = sub(num_s, num_f);
    cout << ans << '\n';

}

signed main() {
    int t = 1; cin >> t;
    while (t--) {
        solve();
    }
}
